/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        22.12.2008
 Description:    Car Delay

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#include <avr/interrupt.h>
#include <avr/io.h>

volatile unsigned int adc_var1 = 1024;
volatile unsigned int adc_var2 = 0;
volatile unsigned int timer = 0;

//############################################################################
//Timer1 Interrupt
ISR (ADC_vect)
//############################################################################
{
    ADCSRA = 0;
    if ((ADMUX&0x0F) == 3)
    {
        adc_var1 = ADC; //Potiwerte einlesen
        ADMUX = 2;
    }
    else
    {
        adc_var2 = ADC; //Sensor einlesen
        ADMUX = 3;
    }
    ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
}

//############################################################################
//Timer1 Interrupt
ISR (TIMER1_OVF_vect)
//############################################################################
{
    timer++;
    TCNT1 = ((unsigned char) (1000000 - (1000000 / 16384) - 1));
}


//############################################################################
//Hauptprogramm
int main (void) 
//############################################################################
{
    //Posts initialisieren
    DDRB |= (1<<PB0);   //Ausgang zum schalten des Relais
    DDRB |= (1<<PB1);   //Port Ausgang fr die LED 
    
    //PORTB |= (1<<PB0);  //Relais on
    
    //Timer init
    TCCR1 |= (1<<CS10 | 1<<CS11 | 1<<CS12 | 1<<CS13);
	TCNT1 = ((unsigned char) (1000000 - (1000000 / 16384) - 1));
	TIMSK |= (1 << TOIE1);
    
    //ADC initialisieren
    ADMUX = 3;
	//Free Running Mode, Division Factor 128, Interrupt on
	ADCSRA = (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
    
    //Globale Interrupts Enable
	sei();
    
	while(1)
	{ 
        if (adc_var2 > adc_var1)
        {
            PORTB |= (1<<PB0);  //Relais on
			PORTB |= (1<<PB1);
			timer = 0;
        }
        
		if (timer > 2)
		{
			PORTB &= ~(1<<PB0);  //Relais off
			PORTB &= ~(1<<PB1);
		}
	}
}

